/*
	ppu.cpp
	fudroyd picture processing unit
	/mic 2009
*/

#include "ppu.h"
#include "memory.h"

tag_ppu ppu;
//unsigned char *dp,*cp,*dp2,c,sx,sy;
unsigned short *dp,*dp2;
unsigned char *cp,c,atr,sx,sy;
unsigned short mapadr;
unsigned short tnu,pal[4],opal0[4],opal1[4],*opal;
unsigned char cgbBgp[64],cgbObp[64];
unsigned short cgbBgpRgb[32],cgbObpRgb[32];
unsigned short dmgPalRgb[4];

int ppu_reset() {
	ppu.mode = 0;
	ppu.scanline = 0;
	REG_LCDC = 0x91;
	REG_LY = 0;
	return 1;
}




void ppu_draw_sprites(int prio, int masterPrio) {
	int i,u,v;
	int spriteNum=0;

	if (MACH_TYPE & 0x80) {
		// CGB
	if (REG_LCDC & 2) {
		dp = &ppu.vscreen[160*ppu.scanline];

		// 8x16 OBJ
		if (REG_LCDC & 4) {
			for (i=0; i<40; i++) {
				sy = OAM[i*4] - 16;
				v = 16;
				if ((sy<=ppu.scanline)&&(sy+15>=ppu.scanline))
					v = ppu.scanline - sy;
				if (v<16) {
					sx = OAM[i*4+1] - 8;
					if ((((OAM[i*4+3]&0x80)==prio)||masterPrio) &&
						((sx>=0)&&(sx<160))) {
						tnu = OAM[i*4+2]&0xFE;
						dp2 = dp + sx;
						if (OAM[i*4+3]&0x40)
							v ^= 15;
						cp = &VRAM[((OAM[i*4+3] & 8) << 10) + tnu*16 + v*2];
						opal = &cgbObpRgb[(OAM[i*4+3] & 7) << 2];
						if (OAM[i*4+3]&0x20) {
							for (u=7; u>=0; u--) {
								c = ((cp[0]>>(7-u))&1) + ((cp[1]>>(7-u))&1)*2;
								if (c!=0)
									*dp2 = opal[c];
								dp2++;
							}
						} else {
							for (u=0; u<8; u++) {
								c = ((cp[0]>>(7-u))&1) + ((cp[1]>>(7-u))&1)*2;
								if (c!=0)
									*dp2 = opal[c];
								dp2++;
							}
						}
					}
				}
			}

		// 8x8 OBJ
		} else {
			for (i=0; i<40; i++) {
				sy = OAM[i*4] - 16;
				v = 8;
				if ((sy<=ppu.scanline)&&(sy+7>=ppu.scanline))
					v = ppu.scanline - sy;
				if (v<8) {
					sx = OAM[i*4+1] - 8;
					if ((((OAM[i*4+3]&0x80)==prio)||masterPrio) &&
						((sx>=0)&&(sx<160))) {
						if (OAM[i*4+3]&0x40)
							v ^= 7;
						tnu = OAM[i*4+2];
						dp2 = dp + sx;
						cp = &VRAM[((OAM[i*4+3] & 8) << 10) + tnu*16 + v*2];
						opal = &cgbObpRgb[(OAM[i*4+3] & 7) << 2];
						if (OAM[i*4+3]&0x20) {
							for (u=7; u>=0; u--) {
								c = ((cp[0]>>(7-u))&1) + ((cp[1]>>(7-u))&1)*2;
								if (c!=0)
									*dp2 = opal[c];
								dp2++;
							}
						} else {
							for (u=0; u<8; u++) {
								c = ((cp[0]>>(7-u))&1) + ((cp[1]>>(7-u))&1)*2;
								if (c!=0)
									*dp2 = opal[c];
								dp2++;
							}
						}
					}
				}
			}
		}
	}
	} else {
		// DMG
	if (REG_LCDC & 2) {
		dp = &ppu.vscreen[160*ppu.scanline];

		// 8x16 OBJ
		if (REG_LCDC & 4) {
			for (i=0; i<40; i++) {
				sy = OAM[i*4] - 16;
				v = 16;
				if ((sy<=ppu.scanline)&&(sy+15>=ppu.scanline))
					v = ppu.scanline - sy;
				if (v<16) {
					sx = OAM[i*4+1] - 8;
					if (((OAM[i*4+3]&0x80)==prio) &&
						((sx>=0)&&(sx<160))) {
						tnu = OAM[i*4+2]&0xFE;
						dp2 = dp + sx;
						if (OAM[i*4+3]&0x40)
							v ^= 15;
						cp = &VRAM[tnu*16 + v*2];
						opal = (OAM[i*4+3]&0x10)?(&opal1[0]):(&opal0[0]);
						if (OAM[i*4+3]&0x20) {
							for (u=7; u>=0; u--) {
								c = ((cp[0]>>(7-u))&1) + ((cp[1]>>(7-u))&1)*2;
								if (c!=0)
									*dp2 = opal[c];
								dp2++;
							}
						} else {
							for (u=0; u<8; u++) {
								c = ((cp[0]>>(7-u))&1) + ((cp[1]>>(7-u))&1)*2;
								if (c!=0)
									*dp2 = opal[c];
								dp2++;
							}
						}
					}
				}
			}

		// 8x8 OBJ
		} else {
			for (i=0; i<40; i++) {
				sy = OAM[i*4] - 16;
				v = 8;
				if ((sy<=ppu.scanline)&&(sy+7>=ppu.scanline))
					v = ppu.scanline - sy;
				if (v<8) {
					sx = OAM[i*4+1] - 8;
					if (((OAM[i*4+3]&0x80)==prio) &&
						((sx>=0)&&(sx<160))) {
						if (OAM[i*4+3]&0x40)
							v ^= 7;
						tnu = OAM[i*4+2];
						dp2 = dp + sx;
						cp = &VRAM[tnu*16 + v*2];
						opal = (OAM[i*4+3]&0x10)?(&opal1[0]):(&opal0[0]);
						if (OAM[i*4+3]&0x20) {
							for (u=7; u>=0; u--) {
								c = ((cp[0]>>(7-u))&1) + ((cp[1]>>(7-u))&1)*2;
								if (c!=0)
									*dp2 = opal[c];
								dp2++;
							}
						} else {
							for (u=0; u<8; u++) {
								c = ((cp[0]>>(7-u))&1) + ((cp[1]>>(7-u))&1)*2;
								if (c!=0)
									*dp2 = opal[c];
								dp2++;
							}
						}
					}
				}
			}
		}
	}
	}
}


void ppu_draw_bg_cgb(int prio, int masterPrio) {
	int i,x,y,bank,xflip,yflip;

	y = (ppu.scanline+REG_SCY) & 7;

	if (REG_LCDC & 0x10) {	// Tiles at 0x8000-0x8FFF
		for (i=0; i<160; i++) {
			tnu = VRAM[mapadr + ((((i+REG_SCX)&0xFF)>>3)&0x1F)];
			atr = VRAM[0x2000 + mapadr + ((((i+REG_SCX)&0xFF)>>3)&0x1F)];
			if (((atr&0x80)==prio)||masterPrio) {
			    xflip = ((atr >> 5) & 1) * 7;
			    yflip = ((atr >> 6) & 1) * 7;
			    x = (i + REG_SCX)&7;
			    cp = &VRAM[((atr & 8) << 10) + tnu*16 + (y^yflip)*2];
			    c = ((cp[0]>>((7-x)^xflip))&1) + ((cp[1]>>((7-x)^xflip))&1)*2;
			    if (c!=0)
				    *dp = cgbBgpRgb[((atr & 7) << 2) + c];
			}
			dp++;
		}

	} else {				// Tiles at 0x8800-0x97FF
		for (i=0; i<160; i++) {
			tnu = VRAM[mapadr + ((((i+REG_SCX)&0xFF)>>3)&0x1F)];
			atr = VRAM[0x2000 + mapadr + ((((i+REG_SCX)&0xFF)>>3)&0x1F)];
			if (((atr&0x80)==prio)||masterPrio) {
			    xflip = ((atr >> 5) & 1) * 7;
			    yflip = ((atr >> 6) & 1) * 7;
			    x = (i + REG_SCX)&7;
			    if (tnu&0x80)
				    cp = &VRAM[((atr & 8) << 10) + 0x800 + (tnu-0x80)*16 + (y^yflip)*2];
			    else
				    cp = &VRAM[((atr & 8) << 10) + 0x1000 + tnu*16 + (y^yflip)*2];
			    c = ((cp[0]>>((7-x)^xflip))&1) + ((cp[1]>>((7-x)^xflip))&1)*2;
			    if (c!=0)
				    *dp = cgbBgpRgb[((atr & 7) << 2) + c];
			}
			dp++;
		}
	}
}


void ppu_draw_wnd_cgb(int prio, int masterPrio) {
	int i,x,y,bank,xflip,yflip;

	y = (ppu.scanline+REG_SCY) & 7;

	if ((REG_LCDC & 0x20) && (ppu.scanline>=REG_WY)) {
		mapadr = (REG_LCDC & 0x40)?0x1C00:0x1800;
		mapadr += (((ppu.scanline-REG_WY)&0xFF)>>3)<<5;
		dp = &ppu.vscreen[160*ppu.scanline] + REG_WX - 7; //- 6;
		y = (ppu.scanline-REG_WY) & 7;

		if (REG_LCDC & 0x10) {	// Tiles at 0x8000-0x8FFF
			for (i=REG_WX-7;/*-6;*/ i<160; i++) {
				tnu = VRAM[mapadr + (((i-REG_WX+7/*+6*/)>>3)&0x1F)];
				atr = VRAM[0x2000 + mapadr + (((i-REG_WX+7/*+6*/)>>3)&0x1F)];
				if (((atr&0x80)==prio)||masterPrio) {
				    x = (i-REG_WX+7/*+6*/)&7;
				    xflip = ((atr >> 5) & 1) * 7;
				    yflip = ((atr >> 6) & 1) * 7;
				    cp = &VRAM[((atr & 8) << 10) + tnu*16 + (y^yflip)*2];
				    c = ((cp[0]>>((7-x)^xflip))&1) + ((cp[1]>>((7-x)^xflip))&1)*2;
				    *dp = cgbBgpRgb[((atr & 7) << 2) + c];
				}
				dp++;
			}

		} else {				// Tiles at 0x8800-0x97FF
			for (i=REG_WX-7;/*-6;*/ i<160; i++) {
				tnu = VRAM[mapadr + (((i-REG_WX+7/*+6*/)>>3)&0x1F)];
				atr = VRAM[0x2000 + mapadr + (((i-REG_WX+7/*+6*/)>>3)&0x1F)];
				if (((atr&0x80)==prio)||masterPrio) {
				    x = (i-REG_WX+7/*+6*/)&7;
				    xflip = ((atr >> 5) & 1) * 7;
				    yflip = ((atr >> 6) & 1) * 7;
				    if (tnu&0x80)
					    cp = &VRAM[((atr & 8) << 10) + 0x800 + (tnu-0x80)*16 + (y^yflip)*2];
				    else
					    cp = &VRAM[((atr & 8) << 10) + 0x1000 + tnu*16 + (y^yflip)*2];
				    c = ((cp[0]>>((7-x)^xflip))&1) + ((cp[1]>>((7-x)^xflip))&1)*2;
				    *dp = cgbBgpRgb[((atr & 7) << 2) + c];
				}
				dp++;
			}
		}
	}
}


void ppu_draw_scanline_cgb() {
	int i,x,y,bank,xflip,yflip;
	unsigned char pal;

	y = (ppu.scanline+REG_SCY) & 7;

	for (i=0; i<160; i++) dp[i] = cgbBgpRgb[0];

	if ((REG_LCDC & 0x80)==0) return;

	ppu_draw_sprites(0x80+((REG_LCDC&1)^1), 0);

	// Draw BG
	ppu_draw_bg_cgb(0x00, (REG_LCDC&1)^1);

	// Draw window
	ppu_draw_wnd_cgb(0x00, (REG_LCDC&1)^1);


	ppu_draw_sprites(0x00, (REG_LCDC&1)^1);
	
	ppu_draw_bg_cgb(0x80+((REG_LCDC&1)^1), 0);
	ppu_draw_wnd_cgb(0x80+((REG_LCDC&1)^1), 0);
}


void ppu_draw_scanline() {
	int i,x,y;

	mapadr = (REG_LCDC & 8)?0x1C00:0x1800;
	mapadr += (((ppu.scanline+REG_SCY)&0xFF)>>3)<<5;
	dp = &ppu.vscreen[160*ppu.scanline];

	if (MACH_TYPE & 0x80) {
	      ppu_draw_scanline_cgb();
	      return;
	}

	y = (ppu.scanline+REG_SCY) & 7;

	pal[0] = dmgPalRgb[REG_BGP&3];
	pal[1] = dmgPalRgb[(REG_BGP>>2)&3];
	pal[2] = dmgPalRgb[(REG_BGP>>4)&3];
	pal[3] = dmgPalRgb[(REG_BGP>>6)&3];

	opal0[0] = dmgPalRgb[REG_OBP0&3];
	opal0[1] = dmgPalRgb[(REG_OBP0>>2)&3];
	opal0[2] = dmgPalRgb[(REG_OBP0>>4)&3];
	opal0[3] = dmgPalRgb[(REG_OBP0>>6)&3];

	opal1[0] = dmgPalRgb[REG_OBP1&3];
	opal1[1] = dmgPalRgb[(REG_OBP1>>2)&3];
	opal1[2] = dmgPalRgb[(REG_OBP1>>4)&3];
	opal1[3] = dmgPalRgb[(REG_OBP1>>6)&3];

	//memset(dp,pal[0],160);
	for (i=0; i<160; i++) dp[i] = pal[0];

	if ((REG_LCDC & 0x80)==0) return;

	ppu_draw_sprites(0x80, 0);

	// Draw BG
	if (REG_LCDC & 1) {
		if (REG_LCDC & 0x10) {	// Tiles at 0x8000-0x8FFF
			for (i=0; i<160; i++) {
				tnu = VRAM[mapadr + ((((i+REG_SCX)&0xFF)>>3)&0x1F)];
				x = (i + REG_SCX)&7;
				cp = &VRAM[tnu*16 + y*2];
				c = ((cp[0]>>(7-x))&1) + ((cp[1]>>(7-x))&1)*2;
				if (c!=0)
					*dp = pal[c];
				dp++;
			}

		} else {				// Tiles at 0x8800-0x97FF
			for (i=0; i<160; i++) {
				tnu = VRAM[mapadr + ((((i+REG_SCX)&0xFF)>>3)&0x1F)];
				x = (i + REG_SCX)&7;
				if (tnu&0x80)
					cp = &VRAM[0x800 + (tnu-0x80)*16 + y*2];
				else
					cp = &VRAM[0x1000 + tnu*16 + y*2];
				c = ((cp[0]>>(7-x))&1) + ((cp[1]>>(7-x))&1)*2;
				if (c!=0)
					*dp = pal[c];
				dp++;
			}
		}
	}

	//return;
	// Draw window
	if ((REG_LCDC & 0x20) && (ppu.scanline>=REG_WY)) {
		mapadr = (REG_LCDC & 0x40)?0x1C00:0x1800;
		mapadr += (((ppu.scanline-REG_WY)&0xFF)>>3)<<5;
		dp = &ppu.vscreen[160*ppu.scanline] + REG_WX - 6;
		y = (ppu.scanline-REG_WY) & 7;

		if (REG_LCDC & 0x10) {	// Tiles at 0x8000-0x8FFF
			for (i=REG_WX-6; i<160; i++) {
				tnu = VRAM[mapadr + (((i-REG_WX+6)>>3)&0x1F)];
				x = (i-REG_WX+6)&7;
				cp = &VRAM[tnu*16 + y*2];
				c = ((cp[0]>>(7-x))&1) + ((cp[1]>>(7-x))&1)*2;
				*dp = pal[c];
				dp++;
			}

		} else {				// Tiles at 0x8800-0x97FF
			for (i=REG_WX-6; i<160; i++) {
				tnu = VRAM[mapadr + (((i-REG_WX+6)>>3)&0x1F)];
				x = (i-REG_WX+6)&7;
				if (tnu&0x80)
					cp = &VRAM[0x800 + (tnu-0x80)*16 + y*2];
				else
					cp = &VRAM[0x1000 + tnu*16 + y*2];
				c = ((cp[0]>>(7-x))&1) + ((cp[1]>>(7-x))&1)*2;
				*dp = pal[c];
				dp++;
			}
		}
	}

	ppu_draw_sprites(0x00, 0);
}


void ppu_mode(int mode) {
	/*if (mode == 0) {
		if (ppu.scanline < 144)
			ppu_draw_scanline();
	}*/

	if ((mode==0) && (ppu.mode!=0)) {
		if (ppu.scanline < 144)
			ppu_draw_scanline();
		ppu.scanline++;
		if (ppu.scanline == 144) {
			mode = 1;
			REG_IF |= 1;
			if ((IME!=0)&&((REG_IE&1)!=0)) {
				REG_IF &= ~1;
				cpu.halted = 0;
				cpu_rst(0x40);
				IME = 0;
			}
		} else if (ppu.scanline == 152) {
			mode = 2;
		} else if (ppu.scanline == 153) {
			mode = 3;
		} else if (ppu.scanline == 154) {
			ppu.scanline = 0;
		}

		if ((mode==0) && (REG_STAT & 8)) {
			REG_IF |= 2;
			if ((IME!=0)&&((REG_IE&2)!=0)) {
				REG_IF &= ~2;
				cpu.halted = 0;
				cpu_rst(0x48);
				IME = 0;
			}
		}

		REG_LY = ppu.scanline;
		if ((REG_LY == REG_LYC) && (REG_STAT & 0x40)){
			REG_IF |= 2;
			REG_STAT |= 4;
			if ((IME!=0)&&((REG_IE&2)!=0)) {
				REG_IF &= ~2;
				cpu.halted = 0;
				cpu_rst(0x48);
				IME = 0;
			}
		} else {
			REG_STAT &= ~4;
		}
	}

	if ((REG_STAT & 0x10) && ((mode==1)||((REG_LCDC&0x80)==0))) {
		REG_IF |= 2;
		if ((IME!=0)&&((REG_IE&2)!=0)) {
			REG_IF &= ~2;
			cpu.halted = 0;
			cpu_rst(0x48);
			IME = 0;
		}
	}
	if ((REG_STAT & 0x20) && (mode==2)) {
		REG_IF |= 2;
		if ((IME!=0)&&((REG_IE&2)!=0)) {
			REG_IF &= ~2;
			cpu.halted = 0;
			cpu_rst(0x48);
			IME = 0;
		}
	}

	ppu.mode = mode;
	REG_STAT = (REG_STAT&0xFC)|mode;

}



